// dswdep.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include "dswdep.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Das einzige Anwendungsobjekt

CWinApp theApp;

using namespace std;


void PrintUsage(void)
{
  _tprintf(_T("Usage:\n\ndswdep sourcefile destinationfile\n\nCopyright 2005 Stefan Kuhr\n\n"));
}

#define PROJECT_START_STR "Project: \""
#define START_DEPENDENCY  "    Begin Project Dependency"
#define START_DEPEND_NAME "    Project_Dep_Name " 


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// MFC initialisieren, Ausgabe und Fehlermeldung bei Fehlern
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// ZU ERLEDIGEN: Fehlercode gem Ihren Anforderungen ndern
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
    if (argc<3)
    {
      PrintUsage();
      return 1;
    }

    CStdioFile fileSrc, fileDest;

    if (!fileSrc.Open(argv[1], CFile::modeRead))
    {
      _tprintf(_T("Failed to open file %s\n"), argv[1]);
      return 1;
    }

    if (!fileDest.Open(argv[2], CFile::modeWrite|CFile::modeCreate))
    {
      _tprintf(_T("Failed to open file %s\n"), argv[2]);
      return 1;
    }



    TRY
    {
      fileDest.WriteString(_T("digraph G {"));

      
      CString strRead;
      CString strLastProject;
      
      while(fileSrc.ReadString(strRead)) 
      {
        if (!strRead.Find(PROJECT_START_STR))
        {
          strRead = strRead.Mid(sizeof(PROJECT_START_STR)-1);
          int iQuote = strRead.Find('\"');
          if (-1!=iQuote)
          {
            strLastProject = strRead.Left(iQuote);
            fileDest.WriteString(_T("\n  "));
            fileDest.WriteString(strLastProject);
          }
        }
        if (!strRead.Find(START_DEPENDENCY))
        {
          fileSrc.ReadString(strRead);
          if (!strRead.Find(START_DEPEND_NAME))
          {
            strRead = strRead.Mid(sizeof(START_DEPEND_NAME)-1);
            fileDest.WriteString(_T("\n  "));
            fileDest.WriteString(strLastProject);
            fileDest.WriteString(_T(" -> "));
            fileDest.WriteString(strRead);
          }
        }
      } 

      fileDest.WriteString(_T("\n}"));

    }
    CATCH(CFileException, exc)
    {

    };
    END_CATCH


	}

	return nRetCode;
}


